/**
  ******************************************************************************
  * File Name          : gpio.h
  * Description        : This file contains all the functions prototypes for 
  *                      the gpio  
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under Ultimate Liberty license
  * SLA0044, the "License"; You may not use this file except in compliance with
  * the License. You may obtain a copy of the License at:
  *                             www.st.com/SLA0044
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __gpio_H
#define __gpio_H
#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* USER CODE BEGIN Private defines */
#define GPIO_RELAY_ACTION_OFF       0
#define GPIO_RELAY_ACTION_ON        1
#define GPIO_RELAY_ACTION_HOLD      2
#define GPIO_RELAY_ACTION_UNKNOW    3  
   
#define GPIO_RELAY1_ACTION_OFF       0
#define GPIO_RELAY1_ACTION_ON        1
#define GPIO_RELAY1_ACTION_HOLD      2
#define GPIO_RELAY1_ACTION_UNKNOW    3  
#define GPIO_RELAY2_ACTION_OFF       4
#define GPIO_RELAY2_ACTION_ON        5
#define GPIO_RELAY2_ACTION_HOLD      6
#define GPIO_RELAY2_ACTION_UNKNOW    7    
/* USER CODE END Private defines */

void MX_GPIO_Init(void);

/* USER CODE BEGIN Prototypes */
extern void Relay_Action_Set(uint8_t action);
extern uint8_t Relay1_Action_Get(void);
extern uint8_t Relay2_Action_Get(void);
extern void getGridTypeSwitchSetting(void) ; 

extern uint8_t is_Relay1_First;
/* USER CODE END Prototypes */

#ifdef __cplusplus
}
#endif
#endif /*__ pinoutConfig_H */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
